#!/usr/local/bin/ruby

=begin
class AnapatObject
  def initialize(name)
	  @name = name
	end
end
=end


class Equivalence
  def initialize(name)
		@name = name
 	  @party = Array.new
		@equivalentObjects = Array.new
	end
	
	def addObject(object)
	  @equivalentObjects.push(object)
	end
	
	def addParty(party)
		@party.push(party)
	end
	
	def getName
		return @name
	end
	
	def getEquivalentObjects(objectType)
    if @equivalentObjects.include?(objectType)
			returnObjects = Array.new
	    @equivalentObjects.each do |equivalentObject|
				if equivalentObject != objectType
					returnObjects.push(equivalentObject)
				end
			end
		end 
		return returnObjects
	end		 
end	

class Party
  def initialize(name)
		@name = name
		@equivalences = Array.new
	end
	
	def addEquivalence(equivalence)
		@equivalences.push(equivalence)
		equivalence.addParty(self)
	end
	
	def printEquivalentItems(objectType)
		@equivalences.each do |equivalence|
			print "O:".concat(@name)
			print "\n"
			print ":".concat(equivalence.getName)
			print "\n"
			(equivalence.getEquivalentObjects(objectType)).each do |object|
				print object.name
				print "\n"
			end
			print "ȏ𑊑lƂčl"
			print "\n\n"
		end
	end

end

