#!/usr/local/bin/ruby
#Object Identifier Identification Scheme

class AnapatObject
  def initialize(name)
    @name = name
    @identifiers = Array.new()
  end

  def addIdentifier(identifier)
    @identifiers.push(identifier)
  end

########for Test##########	
	def printMein
	  print @name
		@identifiers.each{|x| x.printIdentifier}
	end
end

class Identifier
  def setIdentificationScheme(identificationScheme)
    @identificationScheme = identificationScheme
  end

  def setString(string="hoge")
    @string = string
  end
	
	def printIdentifier
	  @identificationScheme.printName
		@string.printString
	end
end

class IdentificationScheme
  def initialize(name)
    @name = name
  end
	
	def printName 
	  print @name
	end
end

class AnapatString
  def initialize(string)
    @value = string
  end

  def value
    print @value
  end
end

#--------Test---------------------
object = AnapatObject.new("fowler ")
identifier = Identifier.new
identifier2 = Identifier.new
identificationScheme = IdentificationScheme.new("ICD10 ")
identificationScheme2 = IdentificationScheme.new("ICD11 ")
string = AnapatString.new("E10 ")
string2 = AnapatString.new("E11 ")

object.addIdentifier(identifier)
object.addIdentifier(identifier2)


identifier.setIdentificationScheme(identificationScheme);
identifier.setString(string)
identifier2.setIdentificationScheme(identificationScheme2);
identifier2.setString(string2)

object.printMein